VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3435
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   3405
   LinkTopic       =   "Form1"
   ScaleHeight     =   3435
   ScaleWidth      =   3405
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ListBox List1 
      Height          =   2595
      ItemData        =   "Form1.frx":0000
      Left            =   120
      List            =   "Form1.frx":001F
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
   Begin VB.Label Label1 
      Caption         =   "Rechtsklick auf die Listbox ffnet das Kontextmenu. Darber knnen Elemente hinzugefgt und gelscht werden."
      Height          =   615
      Left            =   120
      TabIndex        =   1
      Top             =   2760
      Width           =   3135
   End
   Begin VB.Menu mnuList1Context 
      Caption         =   "List1Context"
      Visible         =   0   'False
      Begin VB.Menu mnuNewEntryBefore 
         Caption         =   "Neuer Eintrag &vor diesem"
      End
      Begin VB.Menu mnuNewEntry 
         Caption         =   "Neuer &Eintrag"
      End
      Begin VB.Menu mnuNewEntryAfter 
         Caption         =   "Neuer Eintrag &nach diesem"
      End
      Begin VB.Menu mnuSeperator1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDeleteAll 
         Caption         =   "&Alle Eintrge lschen"
      End
      Begin VB.Menu mnuDeleteEntry 
         Caption         =   "Eintrag &lschen"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" _
                  Alias "SendMessageA" ( _
                         ByVal hWnd As Long, _
                         ByVal uMsg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long

Const LB_ITEMFROMPOINT As Long = &H1A9

Private Sub List1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   Dim tmpX As Long, tmpY As Long, tmpPos As Long
   Dim tmpLng As Long
   
   If Button = vbRightButton Then
      tmpX = CLng(X / Screen.TwipsPerPixelX)
      tmpY = CLng(Y / Screen.TwipsPerPixelY)
      ' lParam erhlt einen DWORD (Long),
      ' - oberes WORD (Integer): Y-Koordinate in Pixel
      ' - unteres WORD (Integer): X-Koordinate in Pixel
      tmpPos = (tmpY * &H10000) Or tmpY
      ' Rckgabe: DWORD (Long),
      ' - oberes WORD (Integer):
      '  -> 0 (Null), wenn ein Eintrag angeklickt wurde
      '  -> 1 (Eins), wenn in den weien Bereich geklickt wurde)
      tmpLng = SendMessage(List1.hWnd, LB_ITEMFROMPOINT, 0&, tmpPos)
      
      ' Wenn (tmpLng And &H10000) = &H10000, dann wurde in den weien
      ' Bereich geklickt
      If (tmpLng And &H10000) = &H10000 Then
         ' Alle Eintrge anzeigen, die sich nicht auf ein spezielles
         ' Element beziehen
         
         mnuDeleteEntry.Enabled = False
         mnuNewEntryBefore.Enabled = False
         mnuNewEntryAfter.Enabled = False
         mnuDeleteAll.Enabled = False
         ' mnuNewEntry ist immer verfgbar
         mnuNewEntry.Enabled = True
      Else
         ' Angeklicktes Element markieren
         List1.ListIndex = tmpLng
         
         ' Alle Eintrge anzeigen, die sich nur auf ein bestimmtes
         ' Element beziehen
         mnuDeleteEntry.Enabled = True
         mnuNewEntryBefore.Enabled = True
         mnuNewEntryAfter.Enabled = True
         mnuDeleteAll.Enabled = True
         ' mnuNewEntry ist immer verfgbar
         mnuNewEntry.Enabled = True
      End If
      
      ' Popup-Menu anzeigen
      Call Me.PopupMenu(mnuList1Context)
   End If
End Sub

Private Sub mnuDeleteAll_Click()
   ' Alle Elemente lschen
   Call List1.Clear
End Sub

Private Sub mnuDeleteEntry_Click()
   ' Gewhltes Element lschen
   Call List1.RemoveItem(List1.ListIndex)
End Sub

Private Sub mnuNewEntry_Click()
   Dim NewEntry As String
   
   ' Elementtext eingeben und hinzufgen
   NewEntry = InputBox("Geben sie den neuen Eintrag ein:", "Neuer Eintrag")
   If Trim$(NewEntry) <> "" Then
      Call List1.AddItem(NewEntry)
   End If
End Sub

Private Sub mnuNewEntryAfter_Click()
   Dim NewEntry As String
   
   ' Elementtext eingeben und hinzufgen
   NewEntry = InputBox("Geben sie den neuen Eintrag ein:", "Neuer Eintrag")
   If Trim$(NewEntry) <> "" Then
      Call List1.AddItem(NewEntry, List1.ListIndex + 1)
   End If
End Sub

Private Sub mnuNewEntryBefore_Click()
   Dim NewEntry As String
   
   ' Elementtext eingeben und hinzufgen
   NewEntry = InputBox("Geben sie den neuen Eintrag ein:", "Neuer Eintrag")
   If Trim$(NewEntry) <> "" Then
      Call List1.AddItem(NewEntry, List1.ListIndex)
   End If
End Sub
